/*
 * Kneron Delay driver
 *
 * Copyright (C) 2019 Kneron, Inc. All rights reserved.
 *
 */

#include <stdint.h>
#include "delay.h"

extern uint32_t SystemCoreClock;

#define CYCLES_PER_LOOP     2   // Typical: SUBS (1) + BCS (1 + P)

void delay_us(unsigned int usec)
{
    uint32_t cycles_per_us, count;

    cycles_per_us = SystemCoreClock / 1000000;
    count = usec * cycles_per_us / CYCLES_PER_LOOP;
    while(count--);
}
