#ifndef __BOARD_KDP520_H__
#define __BOARD_KDP520_H__

/* Common definitions for all boards with KL520 */

#define YES                         1
#define NO                          0

#define SENSOR_ID_HMX2056           0
#define SENSOR_ID_OV9286            1
#define SENSOR_ID_HMXRICA           2
#define SENSOR_ID_GC2145            3
#define SENSOR_ID_SC132GS           4
#define SENSOR_ID_MAX               5
#define SENSOR_ID_EXTERN            0xFE
#define SENSOR_ID_NONE              0xFF

#define IMGSRC_IN_PORT_NONE         0
#define IMGSRC_IN_PORT_MIPI         1
#define IMGSRC_IN_PORT_DPI          2  //DVP port
#define IMGSRC_IN_PORT_UVC          3

#define RES_640_480                 0
#define RES_480_640                 1
#define RES_480_272                 2
#define RES_272_480                 3

#define IMAGE_FORMAT_RGB565         0
#define IMAGE_FORMAT_RAW10          1
#define IMAGE_FORMAT_RAW8           2
#define IMAGE_FORMAT_YCBCR          3

#define IMAGE_TYPE_RGB              0
#define IMAGE_TYPE_IR               1

#define DISPLAY_DEVICE_LCDC         0
#define DISPLAY_DEVICE_LCM          1

#define PANEL_MZT_480X272           1
#define PANEL_ST7789_240X320        2

#define SENSOR_RES_RGB              RES_640_480
#define SENSOR_RES_NIR              RES_480_640
#define IMGSRC_FORMAT_RGB           IMAGE_FORMAT_RGB565
#define IMGSRC_FORMAT_NIR           IMAGE_FORMAT_RAW8

#define CFG_AI_3D_LIVENESS_IN_NONE  0
#define CFG_AI_3D_LIVENESS_IN_SCPU  1
#define CFG_AI_3D_LIVENESS_IN_NCPU  2

/* Specific definitions for each board */

#ifdef BOARD_96
#include "board_kl520_96.h"
#include "board_cfg_96.h"
#elif BOARD_DVP_EXAMPLE
#include "board_kl520_dvp_example.h"
#else
#include "board_kl520_evb.h"
#endif
#ifdef KDP_UVC
#include "board_uvc.h"
#endif
#endif // __BOARD_KDP520_H__
