/*
 * @name : v2k_api.c
 * @brief : Video capture interface for Mozart
 *
 * Copyright (C) 2019 Kneron, Inc. All rights reserved.
 *
 */
#include <stdlib.h>
#include "base.h"
#include "framework/v2k.h"
#include "framework/bitops.h"
#include "framework/utils.h"
#include "framework/framework_errno.h"
#include "kmdw_console.h"


#define VD_TYPE_MAX         1
#define VID_DEV_NUM_LIMIT   2//2

static int _vdc_idx = 0;
static struct video_device_context *video_devices[VID_DEV_NUM_LIMIT];

struct video_device_context *video_devdata(struct v2k_dev_handle *handle) {
    return video_devices[handle->i_rdev];
}

int video_device_register(struct video_device_context *vdc)//, int id)
{
    //if (id >= VID_DEV_NUM_LIMIT)
    //    id = 0;
    /* need a func to assign the slot */
    //DSG(" %s _vdc_idx=%d vdc=%p", __func__, _vdc_idx, vdc);
    video_devices[_vdc_idx++] = vdc;

    return 0;
}

void video_device_release(struct video_device_context *vdc)
{
    if (vdc) 
        free((void*)vdc);

    _vdc_idx--;
}
