#ifndef __KDP_PROF_H__
#define __KDP_PROF_H__

#ifndef LOG_ENABLE

#define dbg_profile_start()
#define dbg_profile_stop(tag)

#else

#include <stdint.h>
#include "cmsis_os2.h"
#include "kmdw_console.h"
#include "kdrv_timer.h"

extern int kdp_prof_is_init;
extern uint32_t kdp_prof_interval_us;
extern uint32_t kdp_prof_start_us;  //micro second
extern uint32_t kdp_prof_end_us;    //micro second

//MAX measure interval ~= 40 second

#define dbg_profile_start()                                        \
    do {                                                           \
        if( ! kdp_prof_is_init ) {                                 \
            kdp_prof_is_init = 1;                                  \
            kdrv_timer_perf_measure_start();                       \
        }                                                          \
        kdrv_timer_perf_measure_get(&kdp_prof_interval_us, &kdp_prof_start_us); \
    } while(0)

#define dbg_profile_stop(tag)                                      \
    do {                                                           \
        kdrv_timer_perf_measure_get(&kdp_prof_interval_us, &kdp_prof_end_us); \
        profile_msg("[TIME] <%s> elapses %d us\n",                 \
                    tag, (kdp_prof_end_us - kdp_prof_start_us));   \
    } while(0)

#endif // LOG_ENABLE

#endif
