/*
 * Standard image size definitions
 */
#ifndef __V2K_IMAGE_H__
#define __V2K_IMAGE_H__

#include "v2k.h"

#define QVGA_LANDSCAPE_WIDTH    320
#define QVGA_LANDSCAPE_HEIGHT   240
#define QVGA_PORTRAIT_WIDTH     240
#define QVGA_PORTRAIT_HEIGHT    320

#define TFT43_WIDTH             480
#define TFT43_HEIGHT            272

#define VGA_LANDSCAPE_WIDTH     640
#define VGA_LANDSCAPE_HEIGHT    480
#define VGA_PORTRAIT_WIDTH      480
#define VGA_PORTRAIT_HEIGHT     640

#define HD_WIDTH                1280
#define HD_HEIGHT               720

#define FHD_WIDTH               1920
#define FHD_HEIGHT              1080

#define HMX_RICA_WIDTH          864
#define HMX_RICA_HEIGHT         491


enum image_input_format {
    image_input_format_rgb565 = 0,
    image_input_format_rgb555,
    image_input_format_rgb444,
    image_input_format_rgb24,
    image_input_format_ycbcr422,
    image_input_format_ycbcr420,
    image_input_format_palette_8,
    image_input_format_palette_4,
    image_input_format_palette_2,
    image_input_format_palette_1,
};

struct video_input_params {
    uint16_t input_xres;
    uint16_t input_yres;
    uint32_t input_fmt;
};

struct kdp_rect {
    uint16_t start_x;
    uint16_t start_y;
    uint16_t end_x;
    uint16_t end_y;
};

int calc_framesize(
        uint16_t frame_width, 
        uint16_t frame_height, 
        uint32_t input_fmt);

#endif
