/**
 * Copyright (C) Kneron Inc. All right reserved
 *
 * @file kapp_inf.h
 * @brief Kneron Inference Application
 */

#ifndef __KAPP_INF_H_
#define __KAPP_INF_H_

#include "ipc.h"
#include "kmdw_model.h"

#include "khost/khost_ipc_generic.h"
#include "khost/khost_ipc_sys_version.h"
#include "khost/khost_ipc_inf_app_tiny_yolo.h"
#include "khost/khost_ipc_inf_app_mobilenet.h"
#include "khost/khost_ipc_inf_app_fid_2d.h"
#include "khost/khost_ipc_inf_app_obejct_detection.h"
#include "khost/khost_ipc_inf_app_person_detection.h"
#include "khost/khost_ipc_inf_app_fd_age_gender.h"
#include "khost/khost_ipc_inf_user.h"

/* #####################
 * ##    functions    ##
 * ##################### */

/**
 * @brief init inference necessary data
 * @return OK
 */
void kapp_inf_init(void);


#endif
