/*
 * Kneron Host UART Communication Application Header
 *
 * Copyright (C) 2019 Kneron, Inc. All rights reserved.
 *
 */

#ifndef __UART_COM_H__
#define __UART_COM_H__

/**
 * @brief Init UART com
 */
void kdp_uart_com_init(void);

/**
 * @brief Read data through UART
 * @param BufferPtr read buffer
 * @param BufferLen read buffer length
 * @return bytes read
 */
int kdp_uart_com_read(uint8_t *BufferPtr, uint32_t BufferLen);

/**
 * @brief Write data through UART
 * @param BufferPtr data
 * @param BufferLen data length
 */
void kdp_uart_com_write(uint8_t *BufferPtr, int32_t BufferLen);

/**
 * @brief Get one char through UART
 * @param BufferPtr read buffer
 * @return 0
 */
int kdp_com_getc(uint8_t *BufferPtr);

/**
 * @brief Put one char through UART
 * @param ch char to put
 */
void kdp_com_putc(char ch);

#endif
