#ifndef __USB_H__
#define __USB_H__

/**
 * @brief Init USB
 */
void usb_init(void);

/**
 * @brief Enter USB idle mode
 */
void usb_idle(void);

void usb_com_register_notification(osThreadId_t tid, uint32_t flags);

/**
 * @brief Set USB notify tid & flags
 * @param tid thread id
 * @param flags notify flags
 */
//void usb_set_notify_flag(osThreadId_t tid, uint32_t flags);

/**
 * @brief Set USB data notify tid & flags
 * @param tid thread id
 * @param flags notify flags
 */
//void usb_set_notify_data_flag(osThreadId_t tid, uint32_t flags);

/**
 * @brief Set USB data notify tid & flags
 * @param tid thread id
 * @param flags notify flags, abort notify flag
 */
void usb_set_abort_flag(osEventFlagsId_t ef_id, uint32_t flags);

/**
 * @brief Read data through USB
 * @param BufferPtr read buffer
 * @param BufferLen read buffer length
 * @param flags read flags
 * @param mode mode
 * @return byte read
 */
int usb_com_read(uint8_t *BufferPtr, uint32_t BufferLen, uint32_t flags, uint32_t mode);

/**
 * @brief Write data through UART
 * @param BufferPtr data
 * @param BufferLen data length
 * @param flags read flags
 * @param mode mode
 * @return 0 on success
 */
int usb_com_write(uint8_t *BufferPtr, uint32_t BufferLen, uint32_t flags, uint32_t mode);

#endif
