#include <stdint.h>
#include "def_share.h"
#include "kmdw_memory.h"

uint16_t APP_id = APP_UNKNOWN;
uint32_t image_pool = 0;
dme_res *dme_od_out = 0;
fd_age_gender_res *dme_agg_out = 0;
uint32_t dme_raw_out = 0;
uint32_t dme_out_len;
uint32_t dme_raw_len;

struct kdp_img_cfg rgb_img_config;
struct kdp_img_cfg nir_img_config;

/* ###########################
 * ##    local functions    ##
 * ########################### */

static uint32_t round_up(uint32_t num)
{
    return ((num + (KDP_COL_MIN - 1)) & ~(KDP_COL_MIN - 1));
}

void init_img_cfg(void)
{
    if(image_pool) return;
    image_pool = kmdw_ddr_reserve(MAX_IMG_SIZE*ISI_BUFFER_MAX); // base address of memory pool
    // rrr
    // image_pool = kmdw_ddr_reserve(1024);
    rgb_img_config.image_mem_addr = image_pool;             // rgb image = 640*480*2
    nir_img_config.image_mem_addr = image_pool + 640*480*2; // nir image = 640*480
}

int get_raw_len(uint32_t raw_out)
{
    int h, c, w, output_num;
    int out_size = 0;

    output_num = *(uint32_t *)raw_out;
    for (int i = 0; i < output_num; i++) {
        h = *(uint32_t *)(raw_out + (5*i+1)*sizeof(uint32_t));
        c = *(uint32_t *)(raw_out + (5*i+2)*sizeof(uint32_t));
        w = *(uint32_t *)(raw_out + (5*i+3)*sizeof(uint32_t));
        out_size = out_size + h * c * round_up(w);
    }

    //output_num+HCWRadixScale+H2C2W2R2S2+FP_DATA1+FP_DATA2
    out_size = (1 + 5*output_num)*sizeof(uint32_t) + out_size;
    return out_size;
}
