/*
 * Kneron Main Entry driver
 *
 * Copyright (C) 2020 Kneron, Inc. All rights reserved.
 *
 */

#include "kneron_mozart.h"                // Device header
#include "cmsis_os2.h"                    // ARM::CMSIS:RTOS2:Keil RTX5
#include "kcomm.h"
#include "kapp_fid.h"

void main_init(int host_mode);

static void kcomm_start()
{
    kcomm_enable_base_cmds();
    kcomm_enable_dme_cmds();
    kcomm_init();
}

/**
 * @brief main, main function
 */
int main(void)
{
    SystemCoreClockUpdate();            // System Initialization
    osKernelInitialize();               // Initialize CMSIS-RTOS

    /* SDK main init */
    main_init(0);

    /* Application entry */
    kcomm_start();

    /* Start RTOS Kernel */
    if (osKernelGetState() == osKernelReady) {
        osKernelStart();
    }

    while(1) {
    }
}
